## hotspot 1.0

=== DESCRIPTION ===
Package: hotspot
Type: Package
Title: Software Hotspot Analysis
Version: 1.0
Date: 2015-10-22
Author: Csaba Farago
Maintainer: Csaba Farago <farago@inf.u-szeged.hu>
Description: Contains data for software hotspot analysis, along with a function performing the analysis itself.
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2015-10-23 15:57:48 UTC; U521684
Repository: CRAN
Date/Publication: 2015-10-23 18:26:11

## hotspot 1.1.0%2Bgit20190211

=== src/CMakeLists.txt ===
# enable more pedantic compiler warnings
include(ECMInstallIcons)
include(ECMAddAppIcon)

include(KDEFrameworkCompilerSettings)
# but allow signal/slot keywords
remove_definitions(-DQT_NO_SIGNALS_SLOTS_KEYWORDS)

option(APPIMAGE_BUILD "configure build for bundling in an appimage" OFF)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(models)

ecm_install_icons(ICONS
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/16-apps-hotspot.png
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/22-apps-hotspot.png
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/32-apps-hotspot.png
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/48-apps-hotspot.png
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/64-apps-hotspot.png
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/128-apps-hotspot.png
    DESTINATION ${ICON_INSTALL_DIR} THEME hicolor)

set(hotspot_SRCS
    main.cpp
    util.cpp

    parsers/perf/perfparser.cpp
    perfrecord.cpp

    mainwindow.cpp
    flamegraph.cpp
    aboutdialog.cpp
    startpage.cpp
    recordpage.cpp
    resultspage.cpp
    resultssummarypage.cpp
    resultstopdownpage.cpp
    resultsbottomuppage.cpp
    resultsflamegraphpage.cpp
    resultscallercalleepage.cpp
    resultsutil.cpp

    # ui files:
    mainwindow.ui
    aboutdialog.ui
    startpage.ui
    recordpage.ui
    resultspage.ui
    resultssummarypage.ui
    resultstopdownpage.ui
    resultsbottomuppage.ui
    resultsflamegraphpage.ui
    resultscallercalleepage.ui

    # resources:
    resources.qrc
)

ecm_add_app_icon(hotspot_SRCS ICONS
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/128-hotspot_app_icon.png
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/512-hotspot_app_icon.png
)

add_executable(hotspot
    ${hotspot_SRCS}
)

target_link_libraries(hotspot
    Qt5::Widgets
    KF5::ThreadWeaver
    KF5::I18n
    KF5::ConfigWidgets
    KF5::CoreAddons
    KF5::ItemViews
    KF5::ItemModels
    KF5::KIOCore
    KF5::KIOFileWidgets
    KF5::KIOWidgets
    KF5::KIONTLM
    KF5::Solid
    KF5::WindowSystem
    models
)

set_target_properties(hotspot
    PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${KDE_INSTALL_BINDIR}"
)

install(TARGETS hotspot RUNTIME DESTINATION ${KDE_INSTALL_BINDIR})

=== tests/modeltests/CMakeLists.txt ===
include_directories(../../src)

ecm_add_test(
    tst_models.cpp
    modeltest.cpp
    LINK_LIBRARIES
        Qt5::Core
        Qt5::Test
        models
    TEST_NAME
        tst_models
)

ecm_add_test(
    tst_timelinedelegate.cpp
    LINK_LIBRARIES
        Qt5::Core
        Qt5::Test
        models
    TEST_NAME
        tst_timelinedelegate
)

=== debian/control ===
Source: hotspot
Section: utils
Priority: optional
Maintainer: Yanhao Mo <yanhaocs@gmail.com>
Build-Depends:
 debhelper (>=11~),
 cmake,
 extra-cmake-modules,
 libkf5threadweaver-dev,
 libkf5i18n-dev,
 libkf5coreaddons-dev,
 libkf5itemviews-dev,
 libkf5itemmodels-dev,
 libkf5kio-dev,
 libkf5configwidgets-dev,
 libkf5solid-dev,
 libkf5windowsystem-dev,
 libelf-dev,
 libdw-dev,
 gettext,
Standards-Version: 4.2.1
Homepage: https://github.com/KDAB/hotspot
Vcs-Git: https://salsa.debian.org/debian/hotspot.git
Vcs-Browser: https://salsa.debian.org/debian/hotspot

Package: hotspot
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 linux-tools-common,
 policykit-1,
Description: GUI tool for performance analysis
 hotspot project is a KDAB R&D effort to create a
 standalone GUI tool for performance data. This tool
 now only support perf output data. But is intended to
 support various other performance data formats in the
 future.

## hotspot 1.1.0+git20180816

=== src/models/CMakeLists.txt ===
add_library(models STATIC
    treemodel.cpp
    topproxy.cpp
    data.cpp
    callercalleemodel.cpp
    costdelegate.cpp
    processmodel.cpp
    processfiltermodel.cpp
    processlist_unix.cpp
    timelinedelegate.cpp
    eventmodel.cpp
    ../util.cpp
)

target_link_libraries(models
    Qt5::Core
    Qt5::Widgets
    KF5::ItemModels
    KF5::ConfigWidgets
)

=== debian/changelog ===
hotspot (1.1.0+git20180816-2) unstable; urgency=medium

  * d/patches: Add a patch to disable testProc temporarily
    (Closes: #914357) .

 -- Yanhao Mo <yanhaocs@gmail.com>  Mon, 07 Jan 2019 16:06:12 +0800

hotspot (1.1.0+git20180816-1) unstable; urgency=low

  * Initial release. Closes: #907393

 -- Yanhao Mo <yanhaocs@gmail.com>  Mon, 27 Aug 2018 17:53:49 +0800

## hotspot 1.1.0+git20190211

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)
project(hotspot VERSION 1.1.0 LANGUAGES CXX C)

if (POLICY CMP0063)
    cmake_policy (SET CMP0063 NEW)
endif (POLICY CMP0063)

if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/perfparser/app/main.cpp" )
    if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
        message( FATAL_ERROR
            "The perfparser git submodule is not initialized.\n"
            "Please run the following commands in the source directory (${PROJECT_SOURCE_DIR}):\n"
            "    git submodule update --init --recursive\n"
        )
    else()
        message( FATAL_ERROR
            "The perfparser submodule is missing - please report a broken source package.\n"
        )
    endif()
endif()

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ ${CMAKE_MODULE_PATH})
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
if(NOT DEFINED CMAKE_INSTALL_RPATH_USE_LINK_PATH)
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE)
endif()

set(CMAKE_CXX_STANDARD 11)

# Enable the test harness
enable_testing()

# Version setup
set(HOTSPOT_VERSION_STRING "${hotspot_VERSION}")

include(FeatureSummary)

find_package(Qt5 5.6 COMPONENTS Core Widgets Network Test REQUIRED)
find_package(LibElf REQUIRED)
find_package(Elfutils REQUIRED) # TODO: make optional, use internal copy
find_package(ECM 1.0.0 NO_MODULE REQUIRED)
find_package(Threads REQUIRED)

if(Qt5_FOUND AND ECM_FOUND)
    set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})
    find_package(KF5 COMPONENTS
        ThreadWeaver
        I18n
        ConfigWidgets
        CoreAddons
        ItemViews
        ItemModels
        KIO
        Solid
        WindowSystem
        REQUIRED
    )
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(ECMAddTests)
include(ECMCoverageOption)
include(ECMEnableSanitizers)

file(RELATIVE_PATH LIBEXEC_REL_PATH
   "${CMAKE_INSTALL_PREFIX}/${KDE_INSTALL_BINDIR}"
   "${CMAKE_INSTALL_PREFIX}/${KDE_INSTALL_LIBEXECDIR}")

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/hotspot-config.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/hotspot-config.h
  @ONLY
)

add_subdirectory(3rdparty)
add_subdirectory(scripts)

include_directories(${CMAKE_CURRENT_BINARY_DIR})
add_subdirectory(src)

add_subdirectory(tests)

=== 3rdparty/CMakeLists.txt ===
include(perfparser.cmake)

=== scripts/CMakeLists.txt ===
configure_file(
    elevate_perf_privileges.sh
    "${PROJECT_BINARY_DIR}/${KDE_INSTALL_LIBEXECDIR}/elevate_perf_privileges.sh"
    @ONLY
)

install(PROGRAMS elevate_perf_privileges.sh DESTINATION ${KDE_INSTALL_LIBEXECDIR})

=== tests/CMakeLists.txt ===
add_subdirectory(test-clients)
add_subdirectory(modeltests)
add_subdirectory(integrationtests)

=== src/models/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,7 @@
     processlist_unix.cpp
     timelinedelegate.cpp
     eventmodel.cpp
+    filterandzoomstack.cpp
     ../util.cpp
 )

=== tests/integrationtests/CMakeLists.txt ===
include_directories(../../src)
include_directories(../../src/models)
include_directories(../../src/parsers/perf)

ecm_add_test(
    ../../src/perfrecord.cpp
    ../../src/util.cpp
    ../../src/models/data.cpp
    ../../src/parsers/perf/perfparser.cpp
    tst_perfparser.cpp
    LINK_LIBRARIES
        Qt5::Core
        Qt5::Test
        KF5::ThreadWeaver
        KF5::CoreAddons
        KF5::WindowSystem
    TEST_NAME
        tst_perfparser
)

set_target_properties(tst_perfparser
    PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${KDE_INSTALL_BINDIR}"
)

add_executable(dump_perf_data
    dump_perf_data.cpp
    ../../src/util.cpp
    ../../src/models/data.cpp
    ../../src/parsers/perf/perfparser.cpp
)
target_link_libraries(dump_perf_data
    Qt5::Core
    Qt5::Test
    KF5::ThreadWeaver
)
set_target_properties(dump_perf_data
    PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${KDE_INSTALL_BINDIR}"
)

=== tests/test-clients/CMakeLists.txt ===
include(CMakePushCheckState)

# Check if static linking works at all.
# For example OpenSuse 42.3 with clang doesn't ship a static libc++.a,
# making static linking fail.
cmake_push_check_state(RESET)
set(CMAKE_REQUIRED_LIBRARIES "-static")
check_cxx_source_compiles("int main() {}" STATIC_LINKING_WORKS)
cmake_pop_check_state()

if (STATIC_LINKING_WORKS)
    add_subdirectory(cpp-minimal-static)
endif()
add_subdirectory(cpp-inlining)
add_subdirectory(cpp-recursion)
add_subdirectory(cpp-locking)
add_subdirectory(cpp-stdin)
add_subdirectory(c-syscalls)
add_subdirectory(cpp-sleep)
add_subdirectory(cpp-threadnames)
add_subdirectory(cpp-parallel)

=== tests/test-clients/c-syscalls/CMakeLists.txt ===
set(CMAKE_BUILD_TYPE RelWithDebInfo)

add_executable(c-syscalls main.c)

=== tests/test-clients/cpp-locking/CMakeLists.txt ===
set(CMAKE_BUILD_TYPE RelWithDebInfo)

add_executable(cpp-locking main.cpp)
target_link_libraries(cpp-locking Threads::Threads)

=== tests/test-clients/cpp-sleep/CMakeLists.txt ===
set(CMAKE_BUILD_TYPE RelWithDebInfo)

add_executable(cpp-sleep main.cpp)
target_link_libraries(cpp-sleep Threads::Threads)

=== tests/test-clients/cpp-threadnames/CMakeLists.txt ===
set(CMAKE_BUILD_TYPE RelWithDebInfo)

add_executable(cpp-threadnames main.cpp)
target_link_libraries(cpp-threadnames Threads::Threads)

=== debian/changelog ===
hotspot (1.1.0+git20190211-1) unstable; urgency=high

  * New release for debian.
  * Update perfparser. (Closes: #921431)

 -- Yanhao Mo <yanhaocs@gmail.com>  Wed, 13 Feb 2019 16:20:45 +0800

=== debian/control ===
--- 
+++ 
@@ -29,7 +29,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
- linux-tools-common,
+ linux-perf,
  policykit-1,
 Description: GUI tool for performance analysis
  hotspot project is a KDAB R&D effort to create a

## hotspot 1.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.1.0)
-project(hotspot VERSION 1.1.0 LANGUAGES CXX C)
+project(hotspot VERSION 1.3.0 LANGUAGES CXX C)
 
 if (POLICY CMP0063)
     cmake_policy (SET CMP0063 NEW)
@@ -19,7 +19,11 @@
     endif()
 endif()
 
-set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ ${CMAKE_MODULE_PATH})
+set(CMAKE_MODULE_PATH
+    ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/perfparser/cmake/
+    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/
+    ${CMAKE_MODULE_PATH}
+)
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTOUIC ON)
 set(CMAKE_AUTORCC ON)
@@ -42,11 +46,12 @@
 
 include(FeatureSummary)
 
-find_package(Qt5 5.6 COMPONENTS Core Widgets Network Test REQUIRED)
+find_package(Qt5 5.10 COMPONENTS Core Widgets Network Test Svg REQUIRED)
 find_package(LibElf REQUIRED)
-find_package(Elfutils REQUIRED) # TODO: make optional, use internal copy
+find_package(Elfutils REQUIRED)
 find_package(ECM 1.0.0 NO_MODULE REQUIRED)
 find_package(Threads REQUIRED)
+find_package(Zstd)
 
 if(Qt5_FOUND AND ECM_FOUND)
     set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})

=== 3rdparty/CMakeLists.txt ===
include(perfparser.cmake)
include(PrefixTickLabels.cmake)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,6 @@
 
 set(hotspot_SRCS
     main.cpp
-    util.cpp
 
     parsers/perf/perfparser.cpp
     perfrecord.cpp
@@ -40,6 +39,7 @@
     resultsflamegraphpage.cpp
     resultscallercalleepage.cpp
     resultsutil.cpp
+    costheaderview.cpp
 
     # ui files:
     mainwindow.ui
@@ -68,6 +68,7 @@
 
 target_link_libraries(hotspot
     Qt5::Widgets
+    Qt5::Svg
     KF5::ThreadWeaver
     KF5::I18n
     KF5::ConfigWidgets
@@ -81,6 +82,7 @@
     KF5::Solid
     KF5::WindowSystem
     models
+    PrefixTickLabels
 )
 
 set_target_properties(hotspot

=== 3rdparty/perfparser/CMakeLists.txt ===
find_package(elfutils)

if (NOT elfutils_FOUND)
  message(STATUS "PerfParser is disabled. Set ELFUTILS_INSTALL_DIR to enable it.")
  return()
endif()

find_package(Zstd)

add_subdirectory(app)
add_subdirectory(tests)

=== src/models/CMakeLists.txt ===
--- 
+++ 
@@ -8,8 +8,10 @@
     processfiltermodel.cpp
     processlist_unix.cpp
     timelinedelegate.cpp
+    timeaxisheaderview.cpp
     eventmodel.cpp
     filterandzoomstack.cpp
+    ../settings.cpp
     ../util.cpp
 )
 
@@ -18,4 +20,5 @@
     Qt5::Widgets
     KF5::ItemModels
     KF5::ConfigWidgets
+    PrefixTickLabels
 )

=== tests/integrationtests/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 ecm_add_test(
     ../../src/perfrecord.cpp
+    ../../src/settings.cpp
     ../../src/util.cpp
     ../../src/models/data.cpp
     ../../src/parsers/perf/perfparser.cpp
@@ -25,6 +26,7 @@
 
 add_executable(dump_perf_data
     dump_perf_data.cpp
+    ../../src/settings.cpp
     ../../src/util.cpp
     ../../src/models/data.cpp
     ../../src/parsers/perf/perfparser.cpp
@@ -38,3 +40,18 @@
     PROPERTIES
     RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${KDE_INSTALL_BINDIR}"
 )
+
+include_directories(
+    ${LIBELF_INCLUDE_DIRS}
+    ${LIBDW_INCLUDE_DIR}/elfutils
+    ${LIBDWARF_INCLUDE_DIRS}
+    perfparser/app
+)
+
+add_executable(elfwalk elfwalk.cpp)
+
+target_link_libraries(elfwalk
+LINK_PRIVATE
+    ${LIBDW_LIBRARIES}
+    ${LIBELF_LIBRARIES}
+)

=== tests/modeltests/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,7 @@
         Qt5::Core
         Qt5::Test
         models
+        PrefixTickLabels
     TEST_NAME
         tst_models
 )
@@ -17,6 +18,7 @@
         Qt5::Core
         Qt5::Test
         models
+        PrefixTickLabels
     TEST_NAME
         tst_timelinedelegate
 )

=== tests/test-clients/CMakeLists.txt ===
--- 
+++ 
@@ -19,3 +19,4 @@
 add_subdirectory(cpp-sleep)
 add_subdirectory(cpp-threadnames)
 add_subdirectory(cpp-parallel)
+add_subdirectory(c-fork)

=== 3rdparty/perfparser/app/CMakeLists.txt ===
add_qtc_library(perfparser_lib STATIC
  ALLOW_ASCII_CASTS
  PUBLIC_DEPENDS
    Qt5::Core
    Qt5::Network
    elfutils::dw
    elfutils::elf
  PUBLIC_INCLUDES ./
  SOURCES
    perfaddresscache.cpp
    perfattributes.cpp perfattributes.h
    perfheader.cpp perfheader.h
    perffilesection.cpp perffilesection.h
    perffeatures.cpp perffeatures.h
    perfdata.cpp perfdata.h
    perfunwind.cpp perfunwind.h
    perfregisterinfo.cpp perfregisterinfo.h
    perfstdin.cpp perfstdin.h
    perfsymboltable.cpp perfsymboltable.h
    perfelfmap.cpp perfelfmap.h
    perfkallsyms.cpp perfkallsyms.h
    perftracingdata.cpp perftracingdata.h
    perfdwarfdiecache.cpp perfdwarfdiecache.h
)

if (ZSTD_FOUND)
    target_include_directories(perfparser_lib PRIVATE ${ZSTD_INCLUDE_DIR})
    target_link_libraries(perfparser_lib PRIVATE ${ZSTD_LIBRARY})
    target_compile_definitions(perfparser_lib PRIVATE HAVE_ZSTD=1)
endif()

add_qtc_executable(perfparser
  DEPENDS
    perfparser_lib
  SOURCES
    main.cpp
)

=== tests/test-clients/c-fork/CMakeLists.txt ===
add_executable(c-fork c-fork.c)

=== tests/test-clients/cpp-inlining/CMakeLists.txt ===
set(CMAKE_BUILD_TYPE RelWithDebInfo)

add_executable(cpp-inlining main.cpp)

=== tests/test-clients/cpp-minimal-static/CMakeLists.txt ===
set(CMAKE_BUILD_TYPE RelWithDebInfo)

add_executable(cpp-minimal-static main.cpp)
target_link_libraries(cpp-minimal-static "-static")

=== debian/changelog ===
hotspot (1.3.0-2ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:53:42 +1100

hotspot (1.3.0-2ubuntu3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:36:29 +0000

hotspot (1.3.0-2ubuntu2) noble; urgency=medium

  * No-change rebuild against libelf1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 00:59:09 +0000

hotspot (1.3.0-2ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Update perf dependency to the Ubuntu version

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 22 Feb 2021 08:37:14 +0100

hotspot (1.3.0-2) unstable; urgency=medium

  * Patch to fix build on mips (Closes: #982870)

 -- Yanhao Mo <yanhaocs@gmail.com>  Sun, 21 Feb 2021 11:26:09 +0800

hotspot (1.3.0-1ubuntu1) hirsute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Update perf dependency to the Ubuntu version 

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 10 Jan 2021 13:58:24 +0100

hotspot (1.3.0-1) unstable; urgency=medium

  * New upstream version 1.3.0 (Closes: #962296)

 -- Yanhao Mo <yanhaocs@gmail.com>  Sat, 09 Jan 2021 17:15:50 +0800

hotspot (1.1.0+git20190211-1ubuntu1) eoan; urgency=medium

  * Update perf dependency to the Ubuntu version

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 14 May 2019 20:36:02 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: hotspot
 Section: utils
 Priority: optional
-Maintainer: Yanhao Mo <yanhaocs@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Yanhao Mo <yanhaocs@gmail.com>
 Build-Depends:
  debhelper (>=11~),
  cmake,
@@ -15,6 +16,7 @@
  libkf5configwidgets-dev,
  libkf5solid-dev,
  libkf5windowsystem-dev,
+ libqt5svg5-dev,
  libelf-dev,
  libdw-dev,
  gettext,
@@ -29,7 +31,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
- linux-perf,
+ linux-tools-common,
  policykit-1,
 Description: GUI tool for performance analysis
  hotspot project is a KDAB R&D effort to create a

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hotspot-$1.tar.gz%" \
   https://github.com/KDAB/hotspot/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## hotspot 1.5.1

=== debian/changelog ===
hotspot (1.5.1-0zneon+24.04+noble+stable+build3) noble; urgency=medium

  * Automatic CI Build

 -- Neon CI <neon@kde.org>  Thu, 25 Dec 2025 23:12:20 +0000

hotspot (1.5.1-0neon) noble; urgency=medium

  [ Carlos De Miane ]
  * New release

  [ Carlos De Maine ]
  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Fri, 05 Jul 2024 13:46:54 +1000

hotspot (1.4.0-0neon) UNRELEASED; urgency=medium

  * New release

 -- Jonathan Esk-Riddell <jr@jriddell.org>  Tue, 06 Dec 2022 17:36:23 +0000

=== debian/control ===
Source: hotspot
Section: utils
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               gettext,
               kf6-extra-cmake-modules,
               kf6-karchive-dev,
               kf6-kauth-dev,
               kf6-kcolorscheme-dev,
               kf6-kconfigwidgets-dev,
               kf6-kcoreaddons-dev,
               kf6-ki18n-dev,
               kf6-kio-dev,
               kf6-kitemmodels-dev,
               kf6-kitemviews-dev,
               kf6-knotifications-dev,
               kf6-kparts-dev,
               kf6-kwindowsystem-dev,
               kf6-kxmlgui-dev,
               kf6-solid-dev,
               kf6-syntax-highlighting-dev,
               kf6-threadweaver-dev,
               libdw-dev,
               libelf-dev,
               libkddockwidgets-qt6-dev,
               libkgraphviewer-dev,
               libqcustomplot-dev,
               librust-rustc-demangle-dev,
               libzstd-dev,
               pkg-kde-tools-neon,
               qt6-5compat-dev,
               qt6-base-dev,
               qt6-svg-dev
Standards-Version: 4.6.2
Homepage: https://github.com/KDAB/hotspot
Vcs-Git: https://invent.kde.org/neon/neon-packaging/hotspot.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/hotspot
Maintainer: Neon CI <neon@kde.org>

Package: hotspot
Architecture: any
Multi-Arch: foreign
Depends: binutils,
         linux-tools-common,
         policykit-1,
         ${misc:Depends},
         ${shlibs:Depends}
Description: GUI tool for performance analysis
 hotspot project is a KDAB R&D effort to create a
 standalone GUI tool for performance data. This tool
 now only support perf output data. But is intended to
 support various other performance data formats in the
 future.

=== debian/rules ===
#!/usr/bin/make -f
# SPDX-License-Identifier: LGPL-2.0-or-later
# # SPDX-FileCopyrightText: 2023 Jonathan Riddell <jr@jriddell.org>

# You must remove unused comment lines for the released package.
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with kf6 --buildsystem kf6

override_dh_auto_configure:
	git submodule init
	git submodule update
	git submodule update
	dh_auto_configure -- \
		--log-level=STATUS \
		-DQT6_BUILD=ON

=== debian/watch ===
version=4
opts="searchmode=plain, \
filenamemangle=s/.+\/@PACKAGE@-v?@ANY_VERSION@\.tar\.gz/@PACKAGE@-$1\.tar\.gz/" \
https://api.github.com/repos/KDAB/hotspot/releases \
https://github.com/KDAB/hotspot/releases/download/v?\d[\.\d]*/@PACKAGE@-v?@ANY_VERSION@.tar.gz

## hotspot 1.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(
    hotspot
    VERSION 1.6.0
    LANGUAGES CXX C
)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/perfparser/cmake/ ${CMAKE_CURRENT_SOURCE_DIR}/cmake/
                      ${CMAKE_MODULE_PATH}
)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
if(NOT DEFINED CMAKE_INSTALL_RPATH_USE_LINK_PATH)
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE
        "Release"
        CACHE STRING "" FORCE
    )
endif()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(APPIMAGE_BUILD "configure build for bundling in an appimage" OFF)
option(QT6_BUILD "configure build to use Qt6/KF6" OFF)

# Enable the test harness
enable_testing()

# Version setup
set(HOTSPOT_VERSION_STRING "${hotspot_VERSION}")

include(HotspotMacrosInternal)
include(FeatureSummary)

if(QT6_BUILD)
    set(QT_MAJOR_VERSION 6)
    set(QT_MIN_VERSION 6.4)
    set(KDDW_SUFFIX "-qt6")
else()
    set(QT_MAJOR_VERSION 5)
    set(QT_MIN_VERSION 5.15)
    set(KDDW_SUFFIX "")
endif()

find_package(
    Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION}
    COMPONENTS Core
               Widgets
               Network
               Test
               Svg
    REQUIRED
)

find_package(LibElf REQUIRED)
find_package(ElfUtils REQUIRED)
find_package(ECM 1.0.0 NO_MODULE REQUIRED)
find_package(Threads REQUIRED)
find_package(Zstd)

find_package(perf)
set_package_properties(
    perf PROPERTIES
    DESCRIPTION "Performance analysis tools for Linux"
    PURPOSE "Underlying system tool to record performance data"
    URL "https://perfwiki.github.io/main/"
    TYPE RUNTIME
)

find_package(objdump)
set_package_properties(
    objdump PROPERTIES
    DESCRIPTION "Utility to generate disassembler"
    PURPOSE "Support for annotating individual instructions"
    URL "https://www.gnu.org/software/binutils/"
    TYPE RUNTIME
)

find_package(LibRustcDemangle)
set_package_properties(
    LibRustcDemangle PROPERTIES
    DESCRIPTION "Demangling for Rust symbols, written in Rust."
    PURPOSE "Demangling of Rust symbols"
    URL "https://github.com/alexcrichton/rustc-demangle"
    TYPE RUNTIME
)

find_package(LibDDemangle)
set_package_properties(
    LibDDemangle PROPERTIES
    DESCRIPTION "Demangling for D symbols, written in D."
    PURPOSE "Demangling of D symbols"
    URL "https://github.com/lievenhey/d_demangler"
    TYPE RUNTIME
)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})
find_package(
    KF${QT_MAJOR_VERSION} 5.42.0
    COMPONENTS ThreadWeaver
               ConfigWidgets
               CoreAddons
               ItemViews
               ItemModels
               KIO
               Solid
               WindowSystem
               Notifications
               IconThemes
               Parts
               I18n
    REQUIRED
)

find_package(KF${QT_MAJOR_VERSION}Archive 5.85.0 CONFIG)
set(KFArchive_FOUND ${KF${QT_MAJOR_VERSION}Archive_FOUND})
find_package(KF${QT_MAJOR_VERSION}SyntaxHighlighting CONFIG)
set(KFSyntaxHighlighting_FOUND ${KF${QT_MAJOR_VERSION}SyntaxHighlighting_FOUND})

find_package(KDDockWidgets${KDDW_SUFFIX} CONFIG)
set_package_properties(
    KDDockWidgets${KDDW_SUFFIX} PROPERTIES
    PURPOSE
        "KDDockWidgets is a Qt dock widget library written by KDAB, suitable for replacing QDockWidget and implementing
 advanced functionalities missing in Qt. https://github.com/KDAB/KDDockWidgets"
    TYPE REQUIRED
)

find_package(QCustomPlot)
set_package_properties(
    QCustomPlot PROPERTIES
    DESCRIPTION "QCustomPlot is a Qt charting library. https://www.qcustomplot.com/"
    PURPOSE "Frequency tab"
    URL "https://www.qcustomplot.com/index.php/download"
    TYPE OPTIONAL
)

find_package(KGraphViewerPart CONFIG)
set_package_properties(
    KGraphViewerPart PROPERTIES
    DESCRIPTION "KGraphViewer (from KDE extragear) is a tool to display graphviz .dot graphs"
    PURPOSE "Call graph in the caller/callee tab"
    URL "https://invent.kde.org/graphics/kgraphviewer"
    TYPE OPTIONAL
)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(ECMAddTests)
include(ECMCoverageOption)
include(ECMEnableSanitizers)

file(RELATIVE_PATH LIBEXEC_REL_PATH "${KDE_INSTALL_FULL_BINDIR}" "${KDE_INSTALL_FULL_LIBEXECDIR}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/hotspot-config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/hotspot-config.h @ONLY)

add_definitions(-DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII -DQT_USE_QSTRINGBUILDER -DQT_NO_FOREACH)
add_compile_options(-Wall -pedantic -Wextra)
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wno-gnu-zero-variadic-macro-arguments)
endif()

add_subdirectory(3rdparty)

include_directories(${CMAKE_CURRENT_BINARY_DIR})
add_subdirectory(src)

if(NOT APPIMAGE_BUILD)
    add_subdirectory(tests)
endif()

install(
    FILES com.kdab.hotspot.xml
    DESTINATION ${KDE_INSTALL_MIMEDIR}
)

find_package(SharedMimeInfo 1.8)
set_package_properties(
    SharedMimeInfo PROPERTIES
    TYPE OPTIONAL
    PURPOSE "Associate hotspot "
)

if(SharedMimeInfo_FOUND)
    update_xdg_mimetypes(${KDE_INSTALL_MIMEDIR})
endif()

install(
    FILES com.kdab.hotspot.desktop
    DESTINATION ${KDE_INSTALL_APPDIR}
)
install(
    FILES com.kdab.Hotspot.appdata.xml
    DESTINATION ${KDE_INSTALL_METAINFODIR}
)
feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
# enable more pedantic compiler warnings
include(ECMInstallIcons)
include(ECMAddAppIcon)

include(KDEFrameworkCompilerSettings)
# but allow signal/slot keywords
remove_definitions(-DQT_NO_SIGNALS_SLOTS_KEYWORDS)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(models)

ecm_install_icons(
    ICONS
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/16-apps-hotspot.png
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/22-apps-hotspot.png
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/32-apps-hotspot.png
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/48-apps-hotspot.png
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/64-apps-hotspot.png
    ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/128-apps-hotspot.png
    DESTINATION
    ${KDE_INSTALL_ICONDIR}
    THEME
    hicolor
)

set(HOTSPOT_SRCS
    main.cpp
    parsers/perf/perfparser.cpp
    perfrecord.cpp
    mainwindow.cpp
    flamegraph.cpp
    aboutdialog.cpp
    startpage.cpp
    recordpage.cpp
    resultspage.cpp
    resultssummarypage.cpp
    resultstopdownpage.cpp
    resultsbottomuppage.cpp
    resultsflamegraphpage.cpp
    resultscallercalleepage.cpp
    resultsbyfilepage.cpp
    resultsdisassemblypage.cpp
    resultsutil.cpp
    costheaderview.cpp
    timelinewidget.cpp
    dockwidgetsetup.cpp
    settingsdialog.cpp
    multiconfigwidget.cpp
    perfoutputwidget.cpp
    perfoutputwidgettext.cpp
    perfoutputwidgetkonsole.cpp
    costcontextmenu.cpp
    initiallystoppedprocess.cpp
    perfcontrolfifowrapper.cpp
    errnoutil.cpp
    recordhost.cpp
    copyabletreeview.cpp
    # ui files:
    mainwindow.ui
    aboutdialog.ui
    startpage.ui
    recordpage.ui
    resultspage.ui
    resultssummarypage.ui
    resultstopdownpage.ui
    resultsbottomuppage.ui
    resultsflamegraphpage.ui
    resultscallercalleepage.ui
    resultsbyfilepage.ui
    resultsdisassemblypage.ui
    timelinewidget.ui
    unwindsettingspage.ui
    flamegraphsettingspage.ui
    debuginfodpage.ui
    callgraphwidget.ui
    callgraphsettingspage.ui
    frequencypage.ui
    disassemblysettingspage.ui
    perfsettingspage.ui
    # resources:
    resources.qrc
)

if(KGraphViewerPart_FOUND)
    set(HOTSPOT_SRCS ${HOTSPOT_SRCS} callgraphwidget.cpp callgraphgenerator.cpp)
endif()

ecm_add_app_icon(HOTSPOT_SRCS ICONS ${CMAKE_CURRENT_SOURCE_DIR}/images/icons/128-apps-hotspot.png)

if(QCustomPlot_FOUND)
    set(HOTSPOT_SRCS ${HOTSPOT_SRCS} frequencypage.cpp)
endif()

add_executable(
    hotspot
    ${HOTSPOT_SRCS}
)

target_link_libraries(
    hotspot
    Qt::Widgets
    Qt::Svg
    KF${QT_MAJOR_VERSION}::ThreadWeaver
    KF${QT_MAJOR_VERSION}::ConfigWidgets
    KF${QT_MAJOR_VERSION}::CoreAddons
    KF${QT_MAJOR_VERSION}::ItemViews
    KF${QT_MAJOR_VERSION}::ItemModels
    KF${QT_MAJOR_VERSION}::KIOCore
    KF${QT_MAJOR_VERSION}::KIOFileWidgets
    KF${QT_MAJOR_VERSION}::KIOWidgets
    KF${QT_MAJOR_VERSION}::Solid
    KF${QT_MAJOR_VERSION}::WindowSystem
    KF${QT_MAJOR_VERSION}::Notifications
    KF${QT_MAJOR_VERSION}::IconThemes
    KF${QT_MAJOR_VERSION}::Parts
    KF${QT_MAJOR_VERSION}::I18n
    models
    PrefixTickLabels
    KDAB::kddockwidgets
)

if(KFArchive_FOUND)
    target_link_libraries(hotspot KF${QT_MAJOR_VERSION}::Archive)
endif()

if(QCustomPlot_FOUND)
    target_link_libraries(hotspot QCustomPlot::QCustomPlot)
endif()

if(KGraphViewerPart_FOUND)
    target_link_libraries(hotspot KGraphViewerPart)
endif()

set_target_properties(hotspot PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${KDE_INSTALL_BINDIR}")

install(
    TARGETS hotspot
    RUNTIME DESTINATION ${KDE_INSTALL_BINDIR}
)

if(NOT KDE_INSTALL_KNOTIFYRCDIR)
    set(KDE_INSTALL_KNOTIFYRCDIR ${KDE_INSTALL_KNOTIFY5RCDIR})
endif()
install(
    FILES hotspot.notifyrc
    DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR}
)

=== tests/test-clients/c-fork/CMakeLists.txt ===
add_executable(
    c-fork
    c-fork.c
)

=== tests/test-clients/c-syscalls/CMakeLists.txt ===
add_executable(
    c-syscalls
    main.c
)

=== tests/test-clients/cpp-recursion/CMakeLists.txt ===
add_executable(
    cpp-recursion
    main.cpp
)

set_target_properties(
    cpp-recursion PROPERTIES RUNTIME_OUTPUT_DIRECTORY
                             "${PROJECT_BINARY_DIR}/${KDE_INSTALL_EXECROOTDIR}/tests/test-clients/cpp-recursion"
)

=== tests/test-clients/cpp-stdin/CMakeLists.txt ===
add_executable(
    cpp-stdin
    main.cpp
)

=== debian/changelog ===
hotspot (1.6.0-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
    + Migrate to Qt6 and KF6. (Closes: #1112994, #1124832)
    + Fix CVE-2023-28144. (Closes: #1033848)
  * debian/control: Update build-deps.
  * debian/control: Replace dependency on policykit-1 with pkexec.
    (Closes: #1025573)
  * debian/patches: Drop old patches.

 -- Boyuan Yang <byang@debian.org>  Tue, 03 Mar 2026 13:33:42 -0500

=== debian/control ===
Source: hotspot
Section: utils
Maintainer: Yanhao Mo <yanhaocs@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 extra-cmake-modules,
 gettext,
 kgraphviewer-dev,
 libdw-dev,
 libelf-dev,
 libkddockwidgets-qt6-dev,
 libkf6configwidgets-dev,
 libkf6coreaddons-dev,
 libkf6i18n-dev,
 libkf6iconthemes-dev,
 libkf6itemmodels-dev,
 libkf6itemviews-dev,
 libkf6kio-dev,
 libkf6parts-dev,
 libkf6solid-dev,
 libkf6syntaxhighlighting-dev,
 libkf6threadweaver-dev,
 libkf6windowsystem-dev,
 libqcustomplot-dev,
 libzstd-dev,
 linux-perf,
 qt6-base-dev,
 qt6-svg-dev,
Standards-Version: 4.7.3
Homepage: https://github.com/KDAB/hotspot
Vcs-Git: https://salsa.debian.org/debian/hotspot.git
Vcs-Browser: https://salsa.debian.org/debian/hotspot

Package: hotspot
Architecture: any
Multi-Arch: foreign
Depends:
 linux-perf,
 pkexec,
 ${misc:Depends},
 ${shlibs:Depends},
Description: GUI tool for performance analysis
 hotspot project is a KDAB R&D effort to create a
 standalone GUI tool for performance data. This tool
 now only support perf output data. But is intended to
 support various other performance data formats in the
 future.

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DQT6_BUILD=ON

execute_before_dh_auto_configure:
	ln -sf ../perfparser 3rdparty/perfparser
	ln -sf ../PrefixTickLabels 3rdparty/PrefixTickLabels

execute_before_dh_clean:
	rm -rf 3rdparty/perfparser
	rm -rf 3rdparty/PrefixTickLabels

override_dh_auto_test:
	# Skip tests that need unavailable rustc_demangle and d_demangle
	dh_auto_test -- \
		ARGS\+="-E 'tst_perfdata|tst_models|tst_perfparser'"

=== debian/watch ===
Version: 5

Template: GitHub
Owner: KDAB
Project: hotspot
